﻿<%@ page language="C#" autoeventwireup="true" inherits="_Default, App_Web_hnw3duza" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">

    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Expires" content="0" />

    <title>GeoEnviron WEB - Rotteanmeldelse</title>
    <link rel="SHORTCUT ICON" href="GEIcon.ico" />
    <link rel="stylesheet" type="text/css" href="StyleSheet.css" />
    <link rel="stylesheet" type="text/css" href="styleSheetCalender_v280.css" />

    <script language="javascript" type="text/javascript" src="JScript/JScriptMain_v243.js"></script>
    <script language="javascript" type="text/javascript" src="JScript/JScriptMoveRat_v243.js"></script>
    <script language="javascript" type="text/javascript" src="JScript/JScriptWait_v243.js"></script>
    <script language="javascript" type="text/javascript" src="JScript/JScriptAddress_v280.js"></script>
    <script language="javascript" type="text/javascript" src="JScript/JScriptCallBack_v340.js"></script>
    <script language="javascript" type="text/javascript" src="JScript/JScriptValidate_v243.js"></script>
    <script language="javascript" type="text/javascript" src="JScript/JScriptCalender_v281.js"></script>
   
    <script language="javascript" type="text/javascript">

    function SetRatLatLng(lat, lng)
    {
        document.getElementById('HiddenField_RatLat').value = lat;
        document.getElementById('HiddenField_RatLng').value = lng;

        document.getElementById('div_mapHelpText').style.display = 'block';
    
        if(document.getElementById('TextBox_Address').value.length == 0)
        {
            GetAddressesLatLng(lat + '\t' + lng);
        }
    }

    function SetTrackingScript(state)
    {
        if (document.getElementById('HiddenField_TrackingScriptEnabled').value == 'true')
        {
            try
            {
                var municipalityCode = document.getElementById('HiddenField_MunicipalityCode').value;
                urchinTracker('/SupplierFormat/56421/GeoEnvironWEBRotteanmeldelse/' + municipalityCode + '/' + state);
                //urchinTracker('/db664602-2461-499c-bb47-cd721d6c46ef/' + state);
            }
            catch (err)
            {
                // DO NOTHING
            }
        }
    }

    var reportClicked = false;

    function Report()
    {
        reportClicked = true;
    
        if(Page_ClientValidate().toString() == 'false')
        {
            alert('Anmeldelsen kan ikke gennemføres, fordi der mangler\npåkrævet data eller fordi data ikke er gyldigt.\n\nSe de røde tekster til højre i skærmbilledet.');
            return;
        }

        CloseMapWindow();

        var address = document.getElementById('TextBox_Address').value;
        var name = document.getElementById('TextBox_Name').value;
        var relation = document.getElementById('DropDownList_Relation').value;
        var tlf = document.getElementById('TextBox_Phone').value;
        var mobile = document.getElementById('TextBox_Mobile').value; 
        var observed = document.getElementById('DropDownList_Observed').value;
        var email = document.getElementById('TextBox_Email').value;
        var comments = document.getElementById('TextBox_Comments').value;
        var contact = '0';
        if(document.getElementById('CheckBox_Contact').checked == true) { contact = '1'; }

        var visitDate = document.getElementById('HiddenField_Visit_Date').value;
        var visitTime = document.getElementById('DropDownList_Visit_Time').value;
    
        var lat = document.getElementById('HiddenField_RatLat').value;
        var lng = document.getElementById('HiddenField_RatLng').value;
        
        if((lat.length > 0) && (lng.length > 0))
        {
            lat = (parseFloat(lat).toFixed(6)).toString();
            lng = (parseFloat(lng).toFixed(6)).toString();
        }

        // Call Tracking script
        SetTrackingScript('slut');

        GetReportRats(address + '\t' + name + '\t' + relation + '\t' + tlf + '\t' + mobile + '\t' + observed + '\t' + email + '\t' + comments + '\t' + contact + '\t' + visitDate + '\t' + visitTime + '\t' + lat + '\t' + lng);
    }
   
    var callbackSend = 0;

    function CallBackTest()
    {
        if(callbackSend == 0)
        {
            callbackSend = 1;
            DisplayWait(1);
        
            var Command = "CallBackTest:";
            var context = new Object();
            context.CommandName = "CallBackTest";
            <%=_callbackstr %>
        }    
    }

    function GetAddresses(value)
    {
        if(callbackSend == 0)
        {
            callbackSend = 1;
            DisplayWait(1);
        
            var Command = "GetAddresses:" + value;
            var context = new Object();
            context.CommandName = "GetAddresses";
            <%=_callbackstr %>
        }    
    }
    
    function GetAddressesLatLng(value)
    {
        if(callbackSend == 0)
        {
            callbackSend = 1;
            DisplayWait(1);
        
            var Command = "GetAddressesLatLng:" + value;
            var context = new Object();
            context.CommandName = "GetAddressesLatLng";
            <%=_callbackstr %>
        }    
    }

    function GetSpecificAddress(value)
    {
        if(callbackSend == 0)
        {
            callbackSend = 1;
            DisplayWait(1);
        
            var Command = "GetSpecificAddress:" + value;
            var context = new Object();
            context.CommandName = "GetSpecificAddress";
            <%=_callbackstr %>
        }    
    }
    
    function GetReportRats(value)
    {
        if(callbackSend == 0)
        {
            callbackSend = 1;
            DisplayWait(1);
        
            var Command = "GetReportRats:" + value;
            var context = new Object();
            context.CommandName = "GetReportRats";
            <%=_callbackstr %>
        }    
    }
    
    function CallBackHandler(result, context) 
    {
        callbackSend = 0;
        DisplayWait(0);
    
        switch(context.CommandName)
        {
            case "CallBackTest": SetCallBackTest(result); break;
            case "GetAddresses": SetAddresses(result); break;
            case "GetSpecificAddress": SetSpecificAddress(result); break;
            case "GetReportRats": SetReportRats(result); break;
            case "GetAddressesLatLng": SetAddresses(result); break;
        }
    }

    function OnError(message, context) 
    {
        callbackSend = 0;
        DisplayWait(0);
        alert("Exception :\n" + message);
    }

    var winMap = null;
    
    function ShowMapWindow()
    {
        if((winMap == null) || (winMap.closed))
        {
            var winWidth = 600;
            var winHeight = 500;
            var winLeft = (screen.width / 2) - (winWidth / 2);
            var winTop = (screen.height / 2) - (winHeight / 2);
            
            winMap = window.open('Map.aspx', 'Map', 'width=' + winWidth + ', height=' + winHeight + ', top=' + winTop + ', left=' + winLeft + ', resizable=0, menubar=0, status=0, scrollbars=0');
        }
        else
        {
            winMap.focus();
        }
    }
    
    function CloseMapWindow()
    {
        if((winMap != null) && (!winMap.closed))
        {
            winMap.close();
        }
        
        return true;
    }
    
    </script>

</head>
<body id="div_body" onload="OnLoad()" style="display:none;">
    <form id="form1" runat="server">
    <div id="div_error" runat="server" style="display:none;"></div>
    <div id="div_main" runat="server" style="left: 10px; position: absolute; top: 10px; display:block;">

        <div style="width:652px; height:123px; font-family:Verdana; font-size:8pt; background-image:url(RotteanmeldelseBG.jpg);">
            
            <a id="div_progVers" runat="server" href="Version.txt" target="_blank" style="float:right; margin-top: 98px; font-size: 8pt; color: white; font-family: Verdana; text-align: right; margin-right: 4px; text-decoration:none;">Ver. x.x.x</a>
            
        </div>

        <div style="width:1100px;">
        <!-- hole Page start -->

            <div class="backgroundColor" style="float:left; width:631px; border-right: gray 1px solid; border-left: gray 1px solid; border-bottom: gray 1px solid; padding-right: 9px; padding-left: 10px; padding-bottom: 6px; padding-top: 4px;">
            <!-- main Page start -->

                <!-- Adresse -->
                <div style="float:left; width:8px; margin-top:8px; border-top: black 1px solid; border-left: black 1px solid; height: 6px;">
                </div>
                <div class="labelHead" style="float:left; width:48px; padding-left: 2px;">
                    Adresse
                </div>
                <div style="float:left; width:570px; border-right: black 1px solid; border-top: black 1px solid; margin-top: 8px; height: 6px;">
                </div>        
                <br style="clear:both;" />
                <div style="width:618px; border-right: black 1px solid; border-left: black 1px solid; border-bottom: black 1px solid; padding-left: 10px; padding-bottom: 10px; padding-top: 4px; margin-bottom: 4px;">
                    <div id="div_address" style="display:block;">

                        <div class="label" style="height:22px; padding-top:4px;">
                            Vælg den adresse hvorpå der er observeret en rotte(r).
                        </div>

                        <div class="label" style="float:left; width:120px; padding-top:4px; height: 22px;">
                        </div>
                        <div id="div_addressHelpText" class="label" style="float:left; width:240px; padding-top:4px; height: 22px; color:Green;">
                            ↓ Skriv adresse
                        </div>
                        <!-- width:246px; -->
                        <div class="label" style="float:left; width:246px; padding-top:4px; height: 22px; color:Blue; text-align:right; text-decoration:underline; cursor:pointer;" onclick="alert('Problem:\nMin adresse er ikke med på listen.\nJeg kan se mit vejnavn, men ikke vælge mit hus-nummer.\n\nLøsning:\nSkriv den fulde adresse incl. hus-nummer og vælg derefter adressen fra listen.\n\nHaveforeningsadresser fremsøges ved at skrive den fulde adresse begyndende med ´Haveforeningen [navn] [husnummer]´. Fx ´Haveforeningen Solhuse 1´.')" onfocus="HideCalendar()">
                            Jeg kan ikke vælge min adresse!
                        </div>
                        <br style="clear:both;" />

                        <div class="label" style="float:left; width:120px; padding-top:4px; height: 22px;">
                            Adresse:
                        </div>
                        <div style="float:left; width:496px; height: 26px; padding-top:1px;"> <!-- width:496px; Width="484px" -->
                            <asp:TextBox ID="TextBox_Address" runat="server" Width="484px" CssClass="textBox" AutoCompleteType="Disabled" MaxLength="80" onkeydown="TextAddressKeyDown(this, event)" onchange="if(reportClicked){Page_ClientValidate();}" onfocus="HideCalendar()"></asp:TextBox>
                        </div>
                        <br style="clear:both;" />

                        <div id="div_map" runat="server" style="display:none;">

                            <div style="float:left; width:119px; padding-top:4px; height: 17px;">
                            </div>
                            <div style="float:left; padding-top:2px;" >
                                <input id="Button_Map" type="button" value="Udpeg på kort" class="button" onclick="ShowMapWindow()" onfocus="HideCalendar()" />
                            </div>
                            <div id="div_mapHelpText" class="label" style="float:left; width:150px; padding-top:6px; height: 15px; color:Green; padding-left:10px; display:none;">
                                √
                            </div>
                            <br style="clear:both;" />
                        
                        </div>
                        
                    </div>
                </div>

                <!-- Anmelder -->
                <div style="float:left; width:8px; margin-top:8px; border-top: black 1px solid; border-left: black 1px solid; height: 6px;">
                </div>
                <div class="labelHead" style="float:left; width:58px; padding-left: 2px;">
                    Anmelder
                </div>
                <div style="float:left; width:560px; border-right: black 1px solid; border-top: black 1px solid; margin-top: 8px; height: 6px;">
                </div>        
                <br style="clear:both;" />
                <div style="width:618px; border-right: black 1px solid; border-left: black 1px solid; border-bottom: black 1px solid; padding-left: 10px; padding-bottom: 10px; padding-top: 4px; margin-bottom: 4px;">
                    <div id="div_anmeldelse" style="display:block;">

                        <div class="label" style="float:left; width:120px; padding-top:4px; height: 22px;">
                            Navn:
                        </div>
                        <div style="float:left; width:202px; height: 25px; padding-top:1px;">
                            <asp:TextBox ID="TextBox_Name" runat="server" Width="182px" CssClass="textBox" AutoCompleteType="Disabled" MaxLength="60" ValidationGroup="group" onfocus="HideCalendar()"></asp:TextBox>
                        </div>
                        <div class="label" style="float:left; width:116px; padding-top:4px; height: 22px;">
                            Relation til adresse:
                        </div>
                        <div id="div_DropDownList_Relation" style="float:left; width:172px; height: 24px; padding-top:2px;">
                            <asp:DropDownList ID="DropDownList_Relation" runat="server" CssClass="dropDownList" Width="170px" Height="19px" onfocus="HideCalendar()">
                                <asp:ListItem Value="0">&lt;Vælg&gt;</asp:ListItem>
                                <asp:ListItem Value="e">Ejer</asp:ListItem>
                                <asp:ListItem Value="l">Lejer</asp:ListItem>
                                <asp:ListItem Value="n">Nabo</asp:ListItem>
                                <asp:ListItem Value="a">Andet</asp:ListItem>
                            </asp:DropDownList>
                        </div>
                        <br style="clear:both;" />

                        <div class="label" style="float:left; width:120px; padding-top:4px; height: 22px;">
                            Tlf. / Mobil:
                        </div>
                        <div style="float:left; width:90px; height: 25px; padding-top:1px;"> <!-- width:202px; Width="87px" -->
                            <asp:TextBox ID="TextBox_Phone" runat="server" Width="84px" CssClass="textBox" AutoCompleteType="Disabled" MaxLength="11" onchange="if(reportClicked){Page_ClientValidate();}" onfocus="HideCalendar()"></asp:TextBox>
                        </div>
                        <div style="float:left; width:8px; height: 25px; padding-top:1px;">
                        </div>                        
                        <div style="float:left; width:104px; height: 25px; padding-top:1px;">
                            <asp:TextBox ID="TextBox_Mobile" runat="server" Width="84px" CssClass="textBox" AutoCompleteType="Disabled" MaxLength="11" onfocus="HideCalendar()"></asp:TextBox>
                        </div>
                        <div class="label" style="float:left; width:55px; padding-top:4px; height: 22px;">
                            Lokalitet:
                        </div>
                        <div id="div_DropDownList_Observed" style="float:left; width:233px; height: 24px; padding-top:2px;">
                            <asp:DropDownList ID="DropDownList_Observed" runat="server" CssClass="dropDownList" Width="231px" Height="19px" onfocus="HideCalendar()">
                                <asp:ListItem Value="0">&lt;Vælg&gt;</asp:ListItem>
                            </asp:DropDownList>
                        </div>
                        <br style="clear:both;" />

                        <div class="label" style="float:left; width:117px; padding-top:4px; height: 22px;">
                        </div>
                        <div style="float:left; width:20px; height: 25px; padding-top:1px;">
                            <input id="CheckBox_Contact" type="checkbox" class="checkBox" onfocus="HideCalendar()" />
                        </div>
                        <div class="label" style="float:left; width:476px; padding-top:4px; height: 22px;">
                            Vil gerne ringes op inden besøg
                        </div>
                        <br style="clear:both;" />

                        <div class="label" style="float:left; width:120px; padding-top:4px; height: 22px;">
                            E-mail:
                        </div>
                        <div style="float:left; width:496px; height: 25px; padding-top:1px;">
                            <asp:TextBox ID="TextBox_Email" runat="server" Width="484px" CssClass="textBox" AutoCompleteType="Disabled" MaxLength="60" onfocus="HideCalendar()"></asp:TextBox>
                        </div>
                        <br style="clear:both;" />

                        <div id="div_visitDateTime" runat="server" style="display:block;">

                            <div class="label" style="float:left; width:120px; padding-top:4px; height: 22px;"><!-- width:80px; -->
                                Ønsket besøgsdato:
                            </div>
                            <div style="float:left; width:90px; height: 25px; padding-top:1px;">
                                <asp:TextBox ID="TextBox_Visit_Date" runat="server" Width="74px" CssClass="textBox" AutoCompleteType="Disabled" MaxLength="10" ReadOnly="True"></asp:TextBox>
                            </div>
                            <div style="float:left; width:38px; height:22px; padding-top:4px;">
                                <img src="Calendar.gif" alt="" onclick="ShowCalendar('TextBox_Visit_Date', 'HiddenField_Visit_Date')" />
                            </div>
                            <div class="label" style="float:left; width:62px; padding-top:4px; height: 22px;">
                                Tidspunkt:
                            </div>
                            <div id="div_DropDownList_Visit_Time" style="float:left; width:300px; height: 25px; padding-top:1px;">
                                <asp:DropDownList ID="DropDownList_Visit_Time" runat="server" CssClass="dropDownList" Width="298px" Height="19px" onfocus="HideCalendar()">
                                    <asp:ListItem Value="null">&lt;Vælg&gt;</asp:ListItem>
                                </asp:DropDownList>
                            </div>
                            <br style="clear:both;" />

                        </div>

                        <div class="label" style="float:left; width:120px; padding-top:4px; height: 83px;">
                            Observeret:
                        </div>
                        <div style="float:left; width:496px; height: 86px; padding-top:1px;">
                            <asp:TextBox ID="TextBox_Comments" runat="server" Width="484px" CssClass="textBox" AutoCompleteType="Disabled" Height="80px" TextMode="MultiLine" onkeydown="MaxLengthReached(this, 1000, event)" onchange="Page_ClientValidate()" onfocus="HideCalendar()"></asp:TextBox>
                        </div>
                        <br style="clear:both;" />
                        
                    </div>
                </div>
                
                <div style="float:left; color:olive; font-size:8pt; padding-top:8px; height:22px;">
                    Udviklet af Geokon A/S
                </div>
                
                <div style="float:right; text-align: right; padding-top:5px; padding-bottom:4px;">
                    <input id="Button_Report" type="button" value="Anmeld" class="button" onclick="Report()" onfocus="HideCalendar()" style="cursor: pointer"/>
                </div>

                <div id="div_modalTitle" runat="server" style="float:right; color:Blue; text-decoration:underline; font-size:8pt; padding-top:8px; padding-right: 20px; height:22px; cursor: pointer" onclick="openModal()">
                    Oplysninger om anvendelse af persondata
                </div>
                
                <!-- The Modal -->
                <div id="GDPRModal" class="modal">
                    <!-- Modal content -->
                    <div class="modal-content">
                        <span class="close" onclick="closeModal()">&times;</span>
                        <h3 id="div_modalContentTitle" runat="server">
                            Oplysninger om anvendelse af persondata
                        </h3>
                        <div id="div_modalContentDescription" runat="server" style="white-space: pre-wrap"></div>
                    </div>
                </div>

                <br style="clear:both;" />
            <!-- main Page end -->
            </div>     

            <div style="float:left; padding-left:10px;">
            <!-- error Page start -->

                <div style="height:75px;">
                </div>

                <div style="height:17px; padding-top:4px;">
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Address" runat="server" ControlToValidate="TextBox_Address" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- Adresse mangler</asp:RequiredFieldValidator>
                    <asp:CustomValidator ID="CustomValidator_Address" runat="server" ClientValidationFunction="ValidateAddress" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- Ikke kendt adresse</asp:CustomValidator>
                </div>

                <div id="div_map_error" runat="server" style="display:none;">
                </div>
                
                <div style="height:40px;">
                </div>
            
                <div style="height:22px; padding-top:4px;">
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Name" runat="server" ControlToValidate="TextBox_Name" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- Navn mangler</asp:RequiredFieldValidator>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Relation" runat="server" ControlToValidate="DropDownList_Relation" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" InitialValue="0">&lt;- Relation til adresse mangler</asp:RequiredFieldValidator>
                </div>
                <div style="height:22px; padding-top:4px;">                
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Phone" runat="server" ControlToValidate="TextBox_Phone" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- Tlf. mangler</asp:RequiredFieldValidator>
                    <asp:RegularExpressionValidator ID="RegularExpressionValidator_Phone" runat="server" ControlToValidate="TextBox_Phone" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" ValidationExpression="\d{2} \d{2} \d{2} \d{2}|\d{4} \d{4}|\d{8}">&lt;- Ikke korrekt Tlf.</asp:RegularExpressionValidator>
                    <asp:RegularExpressionValidator ID="RegularExpressionValidator_Mobile" runat="server" ControlToValidate="TextBox_Mobile" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" ValidationExpression="\d{2} \d{2} \d{2} \d{2}|\d{4} \d{4}|\d{8}">&lt;- Ikke korrekt Mobil</asp:RegularExpressionValidator>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Observed" runat="server" ControlToValidate="DropDownList_Observed" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" InitialValue="0">&lt;- Lokalitet mangler</asp:RequiredFieldValidator>
                </div>
                
                <div style="height:26px;">
                </div>
                
                <div style="height:22px; padding-top:4px;">                
                    <asp:RegularExpressionValidator ID="RegularExpressionValidator_Email" runat="server" ControlToValidate="TextBox_Email" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" ValidationExpression="\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*">&lt;- Ikke en E-mail</asp:RegularExpressionValidator>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Email" runat="server" ControlToValidate="TextBox_Email" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- E-mail mangler</asp:RequiredFieldValidator>
                </div>
                
                <div id="div_visitDateTimeValidator" runat="server" style="height:22px; padding-top:4px; display:block;">
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_VisitDate" runat="server" ControlToValidate="HiddenField_Visit_Date" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" InitialValue="dd-mm-yyyy" Enabled="True">&lt;- Besøgsdato mangler</asp:RequiredFieldValidator>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_VisitTime" runat="server" ControlToValidate="DropDownList_Visit_Time" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt" InitialValue="null" Enabled="True">&lt;- Tidspunkt mangler</asp:RequiredFieldValidator>
                </div>                
                
                <div style="height:22px; padding-top:4px;">                
                    <asp:CustomValidator ID="CustomValidator_Comments" runat="server" ClientValidationFunction="ValidateComments" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- Observeret er for lang. Max 1000 tegn.</asp:CustomValidator>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator_Comments" runat="server" ControlToValidate="TextBox_Comments" Display="Dynamic" Font-Names="Verdana" Font-Size="8pt">&lt;- Observeret mangler</asp:RequiredFieldValidator>
                </div>

            <!-- error Page end -->
            </div>
            <br style="clear:both;" />

        <!-- hole Page end -->
        </div>
        
        <div id="div_connectedTo" runat="server" style="color:Silver; font-size:7pt; font-family:Arial; padding-top:2px;">
            Connected to: NOT CONNECTED
        </div>    
        
        <div id="div_ratFG" 
            style="position:absolute; left:197px; top:84px; width:160px; height:39px; background-image :url('RotteanmeldelseFG2.jpg');">
        </div>        
        
        <div id="div_rat" style="position:absolute; left:0px; top:70px; width:206px; height:53px; background-image :url('RotteanmeldelseFG.jpg');">
        </div>

        <div id="divSelectingNumber" style="display:none; width: 131px; height: 20px; background-color: #ffff00; left: 9px; position: absolute; top: 7px;">
            selectingNumber = 0
        </div>
        
        <select id="SelectAddress" class="dropDownList" style="width:488px; display:none; position: absolute; left: 142px; top: 208px; z-index: 1;" size="10" runat="server" onclick="SelectedAddressClick(this)" onkeydown="SelectedAddressKeyDown(this, event)">
        </select>

        <!-- max-height:136px; -->
        <div id="DivSelectAddress" tabindex="0" class="dropDownList" style="outline: 0px solid transparent; width:486px; display:none; position:absolute; left:142px; top:219px; z-index:1; max-height:136px; overflow:auto;" onkeydown="DivAddressesKeyDown(event)" onfocus="DivAddressesFocus()"></div>
        
        <div id="div_wait" style="display:none; position:absolute; top:0px; left:0px; z-index: 1;">
            <img alt="" src="wait.gif" />
        </div>
        
    </div>    

    <!-- Calender -->

    <!-- width:155px; -->
    <div id="divCalendar" class="boxColor" style="width:211px; display:none; border-right: blue 1px solid; border-top: blue 1px solid; border-left: blue 1px solid; border-bottom: blue 1px solid; padding-right: 2px; padding-left: 2px; padding-bottom: 2px; padding-top: 2px; float: none; z-index: 1; position: absolute; left: 670px; top: 100px;" runat="server">

        <div style="float:left"><input id="ButtonCalPrevYear" class="monthButtonStyle" type="button" value="<" onclick="return GetYear(-1)" /></div>
        <div id="divCalYear" style="float:left;width:166px;height:20px;text-align:center; margin-top: 3px;" runat="server">Current year</div>
        <div style="float:left"><input id="ButtonCalNextYear" class="monthButtonStyle" type="button" value=">" onclick="return GetYear(1)" /></div>
        <br style="clear:both" />

        <div style="float:left"><input id="ButtonCalPrevMonth" class="monthButtonStyle" type="button" value="<" onclick="return GetMonth(-1)" /></div>
        <div id="divCalMonth" style="float:left;width:166px;height:20px;text-align:center; margin-top: 3px;" runat="server">Current Month</div>
        <div style="float:left"><input id="ButtonCalNextMonth" class="monthButtonStyle" type="button" value=">" onclick="return GetMonth(1)" /></div>
        <br style="clear:both" />
        
        <div class="dayText">ma</div>
        <div class="dayText">ti</div>
        <div class="dayText">on</div>
        <div class="dayText">to</div>
        <div class="dayText">fr</div>
        <div class="dayText" style="color:gray;">lø</div>
        <div class="dayText" style="color:gray;">sø</div>
        <br style="clear:both" />
        
        <script language="javascript" type="text/javascript">
            var count = 0;

            for (var i = 1; i < 43; i++)
            {
                count++;

                if ((count == 6) || (count == 7))
                {
                    document.write('<div class="weekColor" style="float:left"><input id="ButtonCal' + i.toString() + '" class="dayButtomStyle" type="button" value="00" onclick="DatePressed(' + i.toString() + ', true);" onmouseover="MouseOverButton(this)" onmouseout="MouseOutButton(this)" /></div>');

                    if (count == 7)
                    {
                        document.write('<br style="clear:both" />');
                        count = 0;
                    }
                }
                else
                {
                    document.write('<div style="float:left"><input id="ButtonCal' + i.toString() + '" class="dayButtomStyle" type="button" value="00" onclick="DatePressed(' + i.toString() + ', false);" onmouseover="MouseOverButton(this)" onmouseout="MouseOutButton(this)" /></div>');
                }
            }

        </script>
        
        <script type="text/javascript">
            function openModal() {
                var modal = document.getElementById('GDPRModal');
                modal.style.display = "block";
            }

            function closeModal() {
                var modal = document.getElementById('GDPRModal');
                modal.style.display = "none";
            }

            // When the user clicks anywhere outside of the modal, close it
            window.onclick = function (event) {
                var modal = document.getElementById('GDPRModal');
                if (event.target === modal) {
                    modal.style.display = "none";
                }
            }
        </script>
       
    </div>

    <div id="divDebug" style="display:none; left: 100px; position: absolute; top: 10px; width: 400px;">
        <asp:TextBox ID="HiddenField_Visit_Date" runat="server" Width="80px">dd-mm-yyyy</asp:TextBox>
    </div>

    <asp:HiddenField ID="HiddenField_TrackingScriptEnabled" runat="server" />
    <asp:HiddenField ID="HiddenField_MunicipalityCode" runat="server" />

    <asp:HiddenField ID="HiddenField_RatLat" runat="server" />
    <asp:HiddenField ID="HiddenField_RatLng" runat="server" />
    <asp:HiddenField ID="HiddenField_SiteLat" runat="server" />
    <asp:HiddenField ID="HiddenField_SiteLng" runat="server" />
    
    <asp:HiddenField ID="HiddenField_Holidays" runat="server" />
    <asp:HiddenField ID="HiddenField_DesiredVisitThreshold" runat="server" />

    </form>

    <script type="text/javascript">document.write(unescape("%3Cscript src='" + (("https:" == document.location.protocol) ? "https://" : "http://") + "tracking.danmark.dk/urchin.js' type='text/javascript'%3E%3C/script%3E"));</script>
    <script type="text/javascript">SetTrackingScript('start');</script>

</body>
</html>
